
#ifndef DPCI8255MULTI_H
#define DPCI8255MULTI_H

#include <linux/ioctl.h> 

#define dpci8255multi_major 166
#define MAXCARD 2
#define REGIONLENGTH 40

#define DPCI8255MULTI_WRITE_PORT      _IOW(dpci8255multi_major, 0 , char)
#define DPCI8255MULTI_READ_PORT       _IOR(dpci8255multi_major, 1 , char)
#define DPCI8255MULTI_WRITE_COUNTER   _IOW(dpci8255multi_major, 2 , int)
#define DPCI8255MULTI_READ_COUNTER    _IOR(dpci8255multi_major, 3 , int)
#define DPCI8255MULTI_SET_REGISTER    _IOW(dpci8255multi_major, 4 , int)
#define DPCI8255MULTI_SET_CONTROLWORD _IOW(dpci8255multi_major, 5 , char)
#define DPCI8255MULTI_GET_CONTROLWORD _IOR(dpci8255multi_major, 6 , char)
#define DEVICE_NAME "dpci8255multi"

/* first 8255 on the card */
#define PORTA1 0
#define PORTB1 1
#define PORTC1 2
#define CONTROLWORD1 3

/*   second 8255 on the card */
#define PORTA2 4
#define PORTB2 5
#define PORTC2 6
#define CONTROLWORD2 7

/* third 8255 on the card */
#define PORTA3 8
#define PORTB3 9
#define PORTC3 10
#define CONTROLWORD3 11

/* forth 8255 on the card */
#define PORTA4 12
#define PORTB4 13
#define PORTC4 14
#define CONTROLWORD4 15

/* fifth 8255 on the card */
#define PORTA5 16
#define PORTB5 17
#define PORTC5 18
#define CONTROLWORD5 19

/* sixth 8255 on the card */
#define PORTA6 20
#define PORTB6 21
#define PORTC6 22
#define CONTROLWORD6 23

/* seventh 8255 on the card */
#define PORTA7 24
#define PORTB7 25
#define PORTC7 26
#define CONTROLWORD7 27

/* eighth 8255 on the card */
#define PORTA8 28
#define PORTB8 29
#define PORTC8 30
#define CONTROLWORD8 31

/* first 8253 on the card */
#define COUNTERA1 32
#define COUNTERA2 33
#define COUNTERA3 34
#define CONTROLWORDC1 35

/* second 8253 on the card */
#define COUNTERB1 36
#define COUNTERB2 37
#define COUNTERB3 38
#define CONTROLWORDC2 39

int WritePci8255MultiPort(int file_desc,int port,char value);
unsigned char ReadPci8255MultiPort(int file_desc,int port);

int WritePci8255MultiControlWord(int file_desc,int port,char value);
unsigned char ReadPci8255MultiControlWord(int file_desc,int port);

int WritePci8255MultiCounter(int file_desc,int number,int value);
int ReadPci8255MultiCounter(int file_desc,int number);
#endif


  

